function J12 = deriv12_irf_criterion(PhiHat,del,param_opt,V);



k      = length(param_opt); 
n      = length(PhiHat);
jacob  = zeros(k,n);
delmat = del*eye(n);


for i = 1:n;
    
    delphi = delmat(:,i);
        
    [g_up,   badg_up]   = numgrad('irf_criterion',param_opt,PhiHat+delphi,V);
    [g_down, badg_down] = numgrad('irf_criterion',param_opt,PhiHat-delphi,V);
    jacob0              = (g_up - g_down)/(2*del);
    
    if max(abs(jacob0)) < 1e15;
        jacob(:,i) = jacob0;
    else
        jacob(:,i) = NaN;
    end;
end;


J12 = jacob;



