clc; format long g; clear all; close all;



% Load PhiHat, V, and W matrices for estimation
%--------------------------------------------------------------------------

% sample size remains fixed
%--------------------------------
load PhiHat
load V
tau    = 1;                                                                % designate vintage period (1=1997:Q1, 41=2007:Q1, 61=2012:Q1, 65=2013:Q1, 67=2013:Q3, 76=2015:Q4)
PhiHat = PhiHat(:,tau); 
V      = V(:,tau); 
%--------------------------------

% % sample size grows with vintage
% %--------------------------------
% load PhiHat_s
% load V_s
% load W_s
% tau    = 1;                                                                % designate vintage period (1=1997:Q1, 41=2007:Q1, 61=2012:Q1, 65=2013:Q1, 67=2013:Q3, 76=2015:Q4)
% PhiHat = PhiHat_s; PhiHat = PhiHat(:,tau); 
% V      = V_s;      V      = V(:,tau); 
% W      = W_s;      W      = W(:,:,tau);
% %--------------------------------

%--------------------------------------------------------------------------


% Estimate CEE model using fmincon.m
%--------------------------------------------------------------------------
% param      = [lambda_f eps_w   eps_p  sigma_q kappa  b    sigma_a]'
param        = [1.13     0.76    0.69   21.00    3.01  0.72  0.10  ]';
LB           = [1.01     0.10    0.25    1.00    0.50  0.30  0.01  ]';
UB           = [3.50     0.9999  0.9999 40.00    9.99  0.95  1000  ]';

options = optimset('HessUpdate','bfgs','Display','iter','TolFun',1e-16,'TolX',1e-14,'MaxFunEvals',1800,'MaxIter',1800);
[param_opt,J,ef,out,lambda,grad,hess] = fmincon('irf_criterion',param,[],[],[],[],LB,UB,[],options,PhiHat,V); 

[J,param_opt,Phi] = irf_criterion(param_opt,PhiHat,V)
%--------------------------------------------------------------------------




