clc; format long g; clear all; close all;



% Load PhiHat, V, and W matrices for estimation
%--------------------------------------------------------------------------

% sample: 1965Q3 - 1999Q1
%--------------------------------
load PhiHat_99q3
load V_99q3
load W_99q3
                                                               
PhiHat = PhiHat_99q3; 
V      = V_99q3; 
W      = W_99q3;
%--------------------------------

% % sample: 1965Q3 - 2003Q2
% %--------------------------------
% load PhiHat_03q4
% load V_03q4
% load W_03q4
%                                                                
% PhiHat = PhiHat_03q4; 
% V      = V_03q4; 
% W      = W_03q4;
% %--------------------------------

% % sample: 1965Q3 - 2008Q4
% %--------------------------------
% load PhiHat_09q2
% load V_09q2
% load W_09q2
%                                                                
% PhiHat = PhiHat_09q2; 
% V      = V_09q2; 
% W      = W_09q2;
% %--------------------------------

% % sample: 1965Q3 - 2012Q4
% %--------------------------------
% load PhiHat_13q2
% load V_13q2
% load W_13q2
%                                                                
% PhiHat = PhiHat_13q2; 
% V      = V_13q2; 
% W      = W_13q2;
% %--------------------------------

% % sample: 1965Q3 - 2015Q2
% %--------------------------------
% load PhiHat_15q4
% load V_15q4
% load W_15q4
%                                                                
% PhiHat = PhiHat_15q4; 
% V      = V_15q4; 
% W      = W_15q4;
% %--------------------------------

%--------------------------------------------------------------------------





% Estimate CEE model using fmincon.m
%--------------------------------------------------------------------------
% param      = [lambda_f eps_w eps_p  sigma_q kappa b     sigma_a]'
param        = [1.20     0.80  0.65   20.82   2.29  0.83  0.50     ]';
LB           = [1.05     0.40  0.25    1.00   1.00  0.30  0.001    ]';
UB           = [2.60     0.98  0.9999 40.00   9.99  0.95  Inf      ]';

options = optimset('HessUpdate','bfgs','Display','iter','TolFun',1e-16,'TolX',1e-14,'MaxFunEvals',1800,'MaxIter',1800);
[param_opt,J,ef,out,lambda,grad,hess] = fmincon('irf_criterion',param,[],[],[],[],LB,UB,[],options,PhiHat,V); 

[J,param_opt,Phi] = irf_criterion(param_opt,PhiHat,V)
%--------------------------------------------------------------------------

 
         

% % Compute parameter standard errors using the delta function method
% %--------------------------------------------------------------------------
% % obtain J11
% output = grad_hess('irf_criterion',param_opt,1e-5,PhiHat,V)
% J11    = output.hessian
% 
% % obtain J12
% tic
% J12    = deriv12_irf_criterion(PhiHat,1e-5,param_opt,V)
% toc
% 
% % approximate asymptotic covariance matrix
% Sigma      = (-J11\J12)*W*(-J11\J12)';
% std_errors = sqrt(diag(Sigma))
% %--------------------------------------------------------------------------




