function Y = multirandn(mu,Omega,T);
%---------------------------------------------------------
% PURPOSE: generate multivariate Gaussian random vectors 
%---------------------------------------------------------
% USAGE: Y     = multirandn(mu,Omega,T)
% where: mu    = mean of random vector
%        Omega = covariance matrix of random vector
%        T     = desired number of random vectors
%---------------------------------------------------------
% RETURNS: an nxT matrix Y whose columns are observations
%          of a random nx1 vector y ~ N(mu,Omega)      
%---------------------------------------------------------
% written by:   Gregory Givens
%               8 April 2010
%---------------------------------------------------------

n = size(Omega,1); 
C = chol(Omega); C = C';
X = randn(n,T);  
Y = repmat(mu,1,T) + C*X;
